<?php defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: helper.php,v 1.3 2009-12-20 20:44:53 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory Hit List 2.0 Modul
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 *
 * H2N Link Directory dTree 2 Modul is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory dTree 2 Modul is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

class mod_ld_hitlists_Helper {

	const USE_LD2_IF_LD_AVAILABLE = 'useLd2IfLdAvailable';
	const NUMBER_OF_LINKS = 'numberOfLinks';
	const VIEW_WEBCATEGORY = 'viewCategory';
	CONST VIEW_WEBLINK_NUMBER = 'viewLinkNumber';
	const VIEW_HIT_COUNTER = 'viewHitCounter';
	const TARGET = 'target';
	const TYPE = 'type';
	const WEBLINK_MODE = 'linkmode';
	const MODULE_CLASS_SFX = 'moduleclass_sfx';
	
	const TEXT_FOR_NONE_CATEGORY = 'textForNoneCategory';
	const VIEW_CATEGORY_IF_NONE_CATEGORY_AVAILABLE = 'viewCategoryIfNoCategoryAvailable';
	const WEBCATGEGORY_LABEL = 'categoryLabel';

	const USE_LD2 = 2;
	const USE_LD  = 1;
	const USE_NONE = 0;

	public function getHitLists(JParameter &$params){
		if (! (JComponentHelper::isEnabled('com_linkirectory',true) ||
		(JComponentHelper::isEnabled('com_linkdirectory2',true) ))) return;

		$numberOfLinks	= intval( $params->get(self::NUMBER_OF_LINKS,5));
		$viewCategory = intval( $params->get(self::VIEW_WEBCATEGORY,1));
		$viewLinkNumber = (bool) $params->get(self:: VIEW_WEBLINK_NUMBER,1);
		$viewHitCounter = (bool) $params->get(self::VIEW_HIT_COUNTER,1);
		$target = intval($params->get(self::TARGET,1));
		$type = intval($params->get(self::TYPE,0));
		$linkmode = intval($params->get(self::WEBLINK_MODE,1));
		$moduleclass_sfx = $params->get(self::MODULE_CLASS_SFX,'');
		$categoryLabel=trim($params->get(self::WEBCATGEGORY_LABEL));
		$useLd2IfLdAvailable = (bool)intval($params->get(self::USE_LD2_IF_LD_AVAILABLE, 1 ));
		$order = self::getOrderWeblinks($type);
		
		$textForNoneCategory = $params->get(self::TEXT_FOR_NONE_CATEGORY);
		$categoryLabel = self::getCategoryLabel($categoryLabel);
		$viewCategoryIfNoCategoryAvailable = $params->get(self::VIEW_CATEGORY_IF_NONE_CATEGORY_AVAILABLE);
		$database = &JFactory::getDBO();

		if ( self::getLdType($useLd2IfLdAvailable) == self::USE_LD) {
			$where = '';
		} else {
			$where = ' OR #__ldlinks.catid = 0 ';
				
		}
		$query = 'SELECT #__ldlinks.*, #__ldcats.name as catname '.
	 				' FROM #__ldlinks LEFT JOIN #__ldcats ON #__ldlinks.catid = #__ldcats.id '.
         			' WHERE #__ldlinks.published = 1 '.
         			' AND ( #__ldcats.published = 1 ' . $where .'  ) ORDER BY '.$order . ' '.
         			' LIMIT 0,'. $numberOfLinks;
		$database->setQuery($query);
		$rows = $database->loadObjectList();
		$counter = 1;
		foreach ($rows as $row) {
			$directUrl=self::getUrlToLink($row->id, $useLd2IfLdAvailable );
			$detailUrl = self::getUrlToLinkDetailPage($row->id, $useLd2IfLdAvailable );
			$catUrl = self::getCategoryUrl($row->catid, $useLd2IfLdAvailable);
			$menuclass = '';
			$directLinkAsHtml=self::getLinkToOpenLink($directUrl,$menuclass,$row->title);
			if ($viewLinkNumber){
				echo '<b>'.$counter.'.&nbsp;</b>';
			}

			switch ($linkmode){
				case 0:
					echo $directLinkAsHtml;
					break;
				case 1:
					echo '<a href="'.$detailUrl.'" class="'. $moduleclass_sfx .'">'.$row->title.'</a>';
					break;
				case 2:
				default:
					echo $directLinkAsHtml . ' <a href="'.$detailUrl.'" class="'. $moduleclass_sfx .'">['.JText::_('LD DETAILS').']</a>';
			}

			if ($viewHitCounter){
				echo " ($row->hits)";
			}

			echo '<br />';
			if ($row->catname == null){
				switch ($viewCategoryIfNoCategoryAvailable){
					case 2:			// Text aus Konfiguration
						$row->catname=$textForNoneCategory;
					case 0:			// keine Kategorie
						break;
					case 1:			// Text aus Sprachdatei
					default:
						$row->catname = JText::_('NONE CATEGORY');		
						break;
				}
			}

			$catAsHtml=self::getHtmlForCategory($row,$categoryLabel,$viewCategory,$catUrl);
			
			if ($catAsHtml && ($row->catname != null)){
				echo '&nbsp;&nbsp;&nbsp;&nbsp;<small>'.$catAsHtml.'</small>';
				echo "<br />";
			}
			$counter++;
		}
	}

	private function getHtmlForCategory(&$row,$categoryLabel,$viewCategory,$catUrl){
		if ($row->catname != null){
			switch ($viewCategory){
				case 1:
					return htmlspecialchars($categoryLabel).':'.$row->catname;
				case 2:
					return htmlspecialchars($categoryLabel).': <a href="'.$catUrl.'">'.$row->catname.'</a>';
				case 0:
				default:
					return '';
				}
			}
		return '';
	}
	
	private function getOrderWeblinks($type){
		switch ($type){
			case 0:
				return "#__ldlinks.created DESC";
			case 1:
				return "#__ldlinks.hits DESC";
			case 2:
				return "#__ldlinks.votes DESC";
			default:
				return "#__ldlinks.created DESC";
		}
	}

	private function getCategoryLabel($categoryLabel){
		if ($categoryLabel==''){
			return JText::_('LD CATEGORY LABEL');
		} else {
			return  htmlspecialchars($categoryLabel);
		}
	}

	private function getLinkToOpenLink($directUrl,$menuclass,$title){
		switch ($target) {
			case 1:
				// open in a new window
				return  '<a href="'. $directUrl .'" target="_blank" class="'. $menuclass .'">'. $title .'</a>';
			case 2:
				// open in a popup window
				return "<a href=\"#\" onclick=\"javascript: window.open('". $directUrl ."', '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550'); return false\" class=\"$menuclass\">". $title ."</a>\n";
			default:
				// open in parent window
				return '<a href="'. $directUrl .'" class="'. $menuclass .'">'. $title .'</a>';
		}
	}

	/**
	 * Ermittelt die URL zur direkten Anzeige der jeweiligen Links
	 * @param int $id Id des Links
	 * @param bool $useLd2IfLdavailable legt fest, ob die Links für 
	 * 			LD2 erzeugt werden sollen, wenn LD2 verfügbar ist
	 * @return direkte URL zum Link
	 */
	private static function getUrlToLink($id=NULL, $useLd2IfLdavailable){
		switch(self::getLdType($useLd2IfLdavailable)){
			case self::USE_LD2:
				return JRoute::_('index.php?option=com_linkdirectory2&task=view&view=link&id='.$id) ;
			case self::USE_LD:
				return JRoute::_('index.php?option=com_linkdirectory&task=view&id='.$id) ;
			default:
				return '';
		}
	}

	/**
	 * Ermittelt die URL zur Detail-Anzeige der jeweiligen Links
	 * @param int $id Id des Links
	 * @param bool $useLd2IfLdavailable legt fest, ob die Links für 
	 * 			LD2 erzeugt werden sollen, wenn LD2 verfügbar ist
	 * @return URL zur Detail-Seite des Links
	 */
	private static function getUrlToLinkDetailPage($id=NULL,$useLd2IfLdAvailable){
		switch(self::getLdType($useLd2IfLdAvailable)){
			case self::USE_LD2:
				return JRoute::_('index.php?option=com_linkdirectory2&view=link&id='.$id) ;
			case self::USE_LD:
				return JRoute::_('index.php?option=com_linkdirectory&task=detail&id='.$id);
			default:
				return '';
		}
	}

	/**
	 * Ermittelt die URL zur Anzeige der jeweiligen Kategorie
	 * @param int $catid Id der Kategorie
	 * @param bool $useLd2IfLdavailable legt fest, ob die Links für 
	 * 			LD2 erzeugt werden sollen, wenn LD2 verfügbar ist
	 * @return URL zur Kategorie
	 */
	private function getCategoryUrl($catid=NULL,$useLd2IfLdAvailable){
		switch(self::getLdType($useLd2IfLdAvailable)){
			case self::USE_LD2;
				$url = 'index.php?option=com_linkdirectory2&view=categories&catid=' . $catid;
				return JRoute::_($url);
			case self::USE_LD;
				$url = 'index.php?option=com_linkdirectory&task=viewcat&catid=' . $catid;
				return JRoute::_($url);
			default:
				return '';
		}
	}

	private function getLdType($useLd2IfLdAvailable){
		if (JComponentHelper::isEnabled('com_linkdirectory2',true) && $useLd2IfLdAvailable){
			return self::USE_LD2;
		}
		if (JComponentHelper:: isEnabled('com_linkdirectory',true)){
			return self::USE_LD;
		}
		return self::USE_NONE;
	}
}

?>